mod Ex04b logic: 'cl'

incl Mtex

incl Mtexg

incl Mauxb

loc rem 
  \para \bf  4. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 15.3.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane explicitnym 
  definiciam a primitivnej rekurzii. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  [CL] Mathematical induction.  \end Syntax: 
  \eq* 
    'ind N ; <variable> ; [<variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(N,x) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex2_bappl1(Tex0_phi,
                                                                                                         x),
                                                                                             Tex2_bappl1(Tex0_phi,
                                                                                                         x+
                                                                                                         1)),
                                                                Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                                             x))),
                            Tex_f0_g_x_nothing)
         \end
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(N,x),y,z) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_forall(y,
                                                                                                Tex_f2_g_forall(z,
                                                                                                                Tex_f2_g_imp(Tex2_bappl1(Tex0_phi,
                                                                                                                                         x),
                                                                                                                             Tex2_bappl1(Tex0_phi,
                                                                                                                                         x+
                                                                                                                                         1)))),
                                                                Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                                             x))),
                            Tex_f0_g_x_nothing)
         \end
  \end

rem 
  \para \bf  Exponentiation.  \end 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Exp(x,y) = 0 <-> x = 0 & y > 0
  \end
  \eq* 
    Exp(x,y) = 1 <-> x = 1 \/ y = 0
  \end

thm Exp_zero
  Exp(x,y) = 0 <-> x = 0 & y > 0

thm Exp_one
  Exp(x,y) = 1 <-> x = 1 \/ y = 0

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Exp(x,y+z) = Exp(x,y)*Exp(x,z)
  \end
  \eq* 
    x > 0 & y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)
  \end

thm Exp_plus
  Exp(x,y+z) = Exp(x,y)*Exp(x,z)

thm Exp_minus
  x > 0 & y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x > 1 -> Exp(x,y) = Exp(x,z) <-> y = z
  \end
  \eq* 
    x > 1 -> Exp(x,y) <= Exp(x,z) <-> y <= z
  \end
  \eq* 
    x > 1 -> Exp(x,y) < Exp(x,z) <-> y < z
  \end

thm Exp_eq
  x > 1 -> Exp(x,y) = Exp(x,z) <-> y = z

thm Exp_le
  x > 1 -> Exp(x,y) <= Exp(x,z) <-> y <= z

thm Exp_lt
  x > 1 -> Exp(x,y) < Exp(x,z) <-> y < z

rem 
  \para \bf  Exercise.  \end Prove 

thm Exp_min
  x > 0 -> Exp(x,Min(y,z)) = Min(Exp(x,y),Exp(x,z))

thm Exp_max
  x > 0 -> Exp(x,Max(y,z)) = Max(Exp(x,y),Exp(x,z))

rem 
  \para \bf  Summation function.  \end 

fun Sum 'Tex_f1_n_sum'
  Sum(0) = 0
  Sum(n+1) = Sum(n)+n+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Sum(n) = 0 <-> n = 0
  \end
  \eq* 
    Sum(n) = n*(n+1)/2
  \end

thm Sum_zero
  Sum(n) = 0 <-> n = 0

thm Sum_closed_form
  Sum(n) = n*(n+1)/2

rem 
  \para \bf  Subsection. Primitive Recursion with Substitution in Parameters. 
   \end 

rem 
  \para \bf  Modified subtraction.  \end 

fun/2 Minus 'Tex_f2_n_minus'
  Minus(0,y) = 0
  Minus(x+1,0) = x+1
  Minus(x+1,y+1) = Minus(x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x >= y -> x = y+Minus(x,y)
  \end
  \eq* 
    x <= y -> Minus(x,y) = 0
  \end

thm Minus_ge
  x >= y -> x = y+Minus(x,y)

thm Minus_le
  x <= y -> Minus(x,y) = 0

